<?php

namespace FiloBlu\Refilo\Controller\Adminhtml\Exporter;

use Exception;
use Magento\Framework\App\Action\HttpGetActionInterface as HttpGetActionInterface;
use Magento\Framework\Controller\ResultFactory;
use Magento\Framework\Exception\LocalizedException;
use Magento\Framework\Message\ManagerInterface;
use FiloBlu\Refilo\Model\Exporter\Search as SearchBlock;

class Search implements HttpGetActionInterface
{
    /**
     * @var
     */
    private $messageManager;
    /**
     * @var ResultFactory
     */
    private $resultFactory;
    /**
     * @var SearchBlock
     */
    private $searchBlock;

    /**
     * Countries constructor.
     * @param ResultFactory $resultFactory
     * @param ManagerInterface $messageManager
     * @param SearchBlock $searchBlock
     */
    public function __construct(
        ResultFactory $resultFactory,
        ManagerInterface $messageManager,
        SearchBlock $searchBlock
    ) {
        $this->resultFactory = $resultFactory;
        $this->messageManager = $messageManager;
        $this->searchBlock = $searchBlock;
    }

    public function execute()
    {
        try {
            //@ToDo Reimplement it as query as soon as a solution for regions is found
            $this->searchBlock->export();
            $this->messageManager->addSuccessMessage(__('Search data successfully synced with MongoDB'));
        } catch (Exception $e) {
            $this->messageManager->addExceptionMessage($e);
        }

        $resultRedirect = $this->resultFactory->create(ResultFactory::TYPE_REDIRECT);
        return $resultRedirect->setPath('indexer/indexer/list/');
    }

}
